{ $HDR$}
{**********************************************************************}
{(c) 2001 Holton Integration Systems}
{**********************************************************************}
{}
{ $Log:  C:\Program Files\Qsc\GP-Version\Archives\AQTest\RecordDelay\unAQRecordDelay.pas.z 
{
{   Rev 1.0    6/4/2001 3:48:26 PM  Eric    Version: 1.0.0.3
{ Init Release
}
{}
unit unAQRecordDelay;

interface

uses AQtest_TLB, Classes, SysUtils, ComObj, ActiveX, Windows, AQRecordDelay_TLB;

type

  TAQRecordDelaySetting = class(TAutoIntfObject, IPTSetting)
  private
    FName:WideString;
    FValue:Boolean;
    FValue2:String;
    FDataType:TDataType;
    FString:TStrings;
  public
    constructor Create;
    destructor Destroy; override;
    function  Get_Name: WideString; safecall;
    function  Get_Description: WideString; safecall;
    procedure Set_Description(const RetVal: WideString); safecall;
    function  Get_Category: WideString; safecall;
    procedure Set_Category(const RetVal: WideString); safecall;
    function  Get_DataType: TDataType; safecall;
    procedure Set_DataType(RetVal: TDataType); safecall;
    function  Get_Kind: TSettingKind; safecall;
    procedure Set_Kind(Value: TSettingKind); safecall;
    function  Get_Value: OleVariant; safecall;
    procedure Set_Value(RetVal: OleVariant); safecall;
    function  Get_MinValue: OleVariant; safecall;
    procedure Set_MinValue(RetVal: OleVariant); safecall;
    function  Get_MaxValue: OleVariant; safecall;
    procedure Set_MaxValue(RetVal: OleVariant); safecall;
    function  Get_Strings: WideString; safecall;
    procedure Set_Strings(const RetVal: WideString); safecall;
    function  CheckItemsCount: Integer; safecall;
    procedure AddCheckItem(const Name: WideString; Checked: WordBool); safecall;
    procedure RemoveCheckItem(Index: Integer); safecall;
    function  Get_CheckItemName(Index: Integer): WideString; safecall;
    procedure Set_CheckItemName(Index: Integer; const Value: WideString); safecall;
    function  Get_CheckItemChecked(Index: Integer): WordBool; safecall;
    procedure Set_CheckItemChecked(Index: Integer; Value: WordBool); safecall;
    function  Get_ButtonClickNotifier: IPTSettingsButtonClickNotifier; safecall;
    procedure Set_ButtonClickNotifier(const Notifier: IPTSettingsButtonClickNotifier); safecall;
    function  Get_Visible: WordBool; safecall;
    procedure Set_Visible(Value: WordBool); safecall;
    function  Get_ReadOnlyCheckList: WordBool; safecall;
    procedure Set_ReadOnlyCheckList(Value: WordBool); safecall;

    property Name: WideString read Get_Name;
    property Description: WideString read Get_Description write Set_Description;
    property Category: WideString read Get_Category write Set_Category;
    property DataType: TDataType read Get_DataType write Set_DataType;
    property Kind: TSettingKind read Get_Kind write Set_Kind;
    property Value: OleVariant read Get_Value write Set_Value;
    property MinValue: OleVariant read Get_MinValue write Set_MinValue;
    property MaxValue: OleVariant read Get_MaxValue write Set_MaxValue;
    property Strings: WideString read Get_Strings write Set_Strings;
    property CheckItemName[Index: Integer]: WideString read Get_CheckItemName write Set_CheckItemName;
    property CheckItemChecked[Index: Integer]: WordBool read Get_CheckItemChecked write Set_CheckItemChecked;
    property ButtonClickNotifier: IPTSettingsButtonClickNotifier read Get_ButtonClickNotifier write Set_ButtonClickNotifier;
    property Visible: WordBool read Get_Visible write Set_Visible;
    property ReadOnlyCheckList: WordBool read Get_ReadOnlyCheckList write Set_ReadOnlyCheckList;
  end;



  TAQRecordDelaySettings = class(TAutoIntfObject, IPTSettings)
  private
    FEnabled:TAQRecordDelaySetting;
    FDelayType:TAQRecordDelaySetting;
    FIndex:Integer;
  public
//IPTSettings
    constructor Create;
    destructor Destroy; override;
    function  Get_Name: WideString; safecall;
    function  Get_HelpFileName: WideString; safecall;
    procedure Set_HelpFileName(const RetVal: WideString); safecall;
    function  Get_HelpContext: Integer; safecall;
    procedure Set_HelpContext(RetVal: Integer); safecall;
    function  Get_Count: Integer; safecall;
    function  Get_Settings(Index: Integer): IPTSetting; safecall;
    function  Get_SettingByName(const Name: WideString): IPTSetting; safecall;
    function  CreateSetting(const SettingName: WideString): IPTSetting; safecall;
    procedure AddNotifier(const PTSettingsNotifier: IPTSettingsNotifier); safecall;
    procedure RemoveNotifier(const PTSettingsNotifier: IPTSettingsNotifier); safecall;
    procedure UpdateSettings; safecall;
    procedure ExecuteForm(HelpContextID: Integer); safecall;
    procedure ReadSettings(const Options: IPTOptions); safecall;
    procedure SaveSettings(const Options: IPTOptions); safecall;
    procedure Set_FocusedIndex(RetVal: Integer); safecall;
    function  Get_FocusedIndex: Integer; safecall;
    procedure AddCancelNotifier(const Notifier: IPTSettingsCancelNotifier); safecall;
    procedure RemoveCancelNotifier(const Notifier: IPTSettingsCancelNotifier); safecall;
    procedure CancelSettings; safecall;
  end;


  TAQRecordDelayObj = class(TAutoIntfObject, IAQRecordDelay)
  private
  public
    constructor Create;
//IAQRecordDelay
    function  WaitWindowVisible(const WndClass: WideString; const WndCaption: WideString;
                                WndIndex: Integer; WaitTime: Integer): IDispatch; safecall;
  end;

  TAQRecordDelay = class(TInterfacedObject, IPTEngine, IPTEngineNotifier,
      {IPTLowRecorderNotifier,} IPTSettingsCancelNotifier, IPTHighRecorderNotifier)
  private
    FPTSettings:IPTSettings;
    FSettingsHolder:TAQRecordDelaySettings;
    FIcon: HICON;
    FEnabled: Boolean;
    FDelayStart: TDateTime;
    FKey:Boolean;
    FHandle:THandle;
    FEngineEnabled:Boolean;
    FScriptLang:TScriptLang;
    FLineType:Integer;
    function GetEnabled: Boolean;
  protected
    function GetDelayTime:Integer;
    function  AddDelay:String;
    procedure UpdateCaption;
    procedure SetLineType(LineStr:String);
  public
    constructor Create;
    destructor Destroy; override;
//IPTHighRecorderNotifier
    procedure OnClick(const AQtestObject: IAQtestObjectControl; X: Integer; Y: Integer;
                      out Verb: WideString); safecall;
    procedure OnClickM(const AQtestObject: IAQtestObjectControl; X: Integer; Y: Integer;
                       out Verb: WideString); safecall;
    procedure OnClickR(const AQtestObject: IAQtestObjectControl; X: Integer; Y: Integer;
                       out Verb: WideString); safecall;
    procedure OnClickX1(const AQtestObject: IAQtestObjectControl; X: Integer; Y: Integer; 
                        out Verb: WideString); safecall;
    procedure OnClickX2(const AQtestObject: IAQtestObjectControl; X: Integer; Y: Integer; 
                        out Verb: WideString); safecall;
    procedure OnDblClick(const AQtestObject: IAQtestObjectControl; X: Integer; Y: Integer; 
                         out Verb: WideString); safecall;
    procedure OnDblClickM(const AQtestObject: IAQtestObjectControl; X: Integer; Y: Integer;
                          out Verb: WideString); safecall;
    procedure OnDblClickR(const AQtestObject: IAQtestObjectControl; X: Integer; Y: Integer; 
                          out Verb: WideString); safecall;
    procedure OnDblClickX1(const AQtestObject: IAQtestObjectControl; X: Integer; Y: Integer; 
                           out Verb: WideString); safecall;
    procedure OnDblClickX2(const AQtestObject: IAQtestObjectControl; X: Integer; Y: Integer; 
                           out Verb: WideString); safecall;
    procedure OnDrag(const AQtestObject: IAQtestObjectControl; X: Integer; Y: Integer; 
                     toX: Integer; toY: Integer; out Verb: WideString); safecall;
    procedure OnDragM(const AQtestObject: IAQtestObjectControl; X: Integer; Y: Integer; 
                      toX: Integer; toY: Integer; out Verb: WideString); safecall;
    procedure OnDragR(const AQtestObject: IAQtestObjectControl; X: Integer; Y: Integer; 
                      toX: Integer; toY: Integer; out Verb: WideString); safecall;
    procedure OnDragX1(const AQtestObject: IAQtestObjectControl; X: Integer; Y: Integer; 
                       toX: Integer; toY: Integer; out Verb: WideString); safecall;
    procedure OnDragX2(const AQtestObject: IAQtestObjectControl; X: Integer; Y: Integer; 
                       toX: Integer; toY: Integer; out Verb: WideString); safecall;
    procedure OnKeyPress(const AQtestObject: IAQtestObjectControl; Scan: Integer; VK: Integer;
                         out Verb: WideString); safecall;
    procedure OnNewContextWindow(const AQtestObject: IAQtestObjectWindow; out Verb: WideString); safecall;
    procedure OnNewContextProcess(const AQtestProcess: IAQtestObjectProcess; out Verb: WideString); safecall;
    function  OnWillProcessEvent(const AQtestObject: IAQtestObject; HighEvent: THighEvents;
                                 out Verb: WideString): WordBool; safecall;



  //IPEngine
    function  Get_Name: WideString; safecall;
    function  Get_Category: WideString; safecall;
    function  Get_Icon: SYSUINT; safecall;
    function  Get_Settings: IPTSettings; safecall;

  //  IPTEngineNotifier
    procedure OnRecordStart; safecall;
    procedure OnRecordStop; safecall;
    procedure OnRecordPause; safecall;
    procedure OnRecordResume; safecall;
    procedure OnExecuteStart(const ProcedureName: WideString); safecall;
    procedure OnExecuteStop; safecall;
    procedure OnExecutePause; safecall;
    procedure OnExecuteResume; safecall;
    procedure OnChangeState(State: TEngineState); safecall;
{ // IPTLowRecorderNotifier
    procedure OnKeyDown(Scan: Integer; VK: Integer); safecall;
    procedure OnKeyUp(Scan: Integer; VK: Integer); safecall;
    procedure OnMouseDown(VK: Integer; X: Integer; Y: Integer); safecall;
    procedure OnMouseUp(VK: Integer; X: Integer; Y: Integer); safecall;
    procedure OnMouseMove(X: Integer; Y: Integer); safecall;
    procedure OnMouseWheel(zDelta: Integer); safecall;
}
// IPTSettingsCancelNotifier
    procedure OnCancel; safecall;

    property Enabled: Boolean read GetEnabled write FEnabled;
  end;

var
  FAQDelay:IDispatch;
  AQRecordDelayPlugIn: TAQRecordDelay;
  PIManager: IPIManager;
  OldWndProc: Pointer;

{ export functions }
function AQtestPlugInInit(PlugInManager: IPIBaseManager): WordBool; stdcall;
procedure AQtestPlugInFinalize; stdcall;
function AQtestPlugInDescription: WideString; stdcall;

function SubclassedWndProc(Hwnd:HWND; Msg:UINT; wParam:WPARAM; lParam:lParam):LResult; stdcall;

implementation
uses
  Messages;

resourcestring
rsRecordDelay = 'RecordDelay';

const
  mSecFactor = 86400000;

{ TAQRecordDelay }



function GetModuleTypeLib: ITypeLib;

  function GetModuleFileName: string;
  var
    Buffer: array[0..261] of Char;
  begin
    SetString(Result, Buffer, Windows.GetModuleFileName(HInstance,
      Buffer, SizeOf(Buffer)));
  end;

  function LoadTypeLibrary(const ModuleName: string): ITypeLib;
  begin
    OleCheck(LoadTypeLib(PWideChar(WideString(ModuleName)), Result));
  end;

begin
  Result := LoadTypeLibrary(GetModuleFileName);
end;


function GetAQTestTypeLib: ITypeLib;
begin
  OleCheck(LoadRegTypeLib(LIBID_AQtest,AQtestMajorVersion,AQtestMinorVersion,0,Result));
end;

constructor TAQRecordDelay.Create;
begin
  inherited Create;
  FSettingsHolder := TAQRecordDelaySettings.Create;
  FPTSettings := FSettingsHolder;
end;

destructor TAQRecordDelay.Destroy;
begin
  FSettingsHolder.Free;
  inherited;
end;

procedure TAQRecordDelay.OnChangeState(State: TEngineState);
begin
end;


procedure TAQRecordDelay.OnExecuteStart(const ProcedureName: WideString);
begin

end;

procedure TAQRecordDelay.OnExecuteStop;
begin

end;


procedure TAQRecordDelay.OnRecordPause;
begin
  FEnabled := False;
end;

procedure TAQRecordDelay.OnRecordResume;
begin
  FDelayStart := Now;
  FEnabled := True;
  UpdateCaption;
end;

procedure TAQRecordDelay.OnRecordStart;
begin
  FEnabled := True;
  FDelayStart := 0;
  FScriptLang := PIManager.Project.ScriptLang;

  UpdateCaption;
end;

procedure TAQRecordDelay.OnRecordStop;
begin
  FEnabled := False;
end;


function TAQRecordDelay.GetEnabled: Boolean;
begin
  Result := FEnabled and FEngineEnabled;
end;

function  TAQRecordDelay.AddDelay:String;
var
  Diff:Integer;
  ContextWindow:OleVariant;
  WndCaption:String;
  WndClass:String;
  WndIndex:Integer;
  Verb:String;
begin
  if Enabled and (FDelayStart <> 0) then
  begin
    Diff := GetDelayTime;
    //PIManager.Recorder.AddString(Format('  Sys.Delay(%d);',[Diff]));
    ContextWindow := PIManager.Recorder.ContextWindow;
    WndClass := ContextWindow.WndClass;
    WndCaption := ContextWindow.WndCaption;
    WndIndex := ContextWindow.WndIndex;
    case FLineType of    //
      0: Verb := Format('  Sys.Delay(%d);',[Diff]);
      1: Verb := Format('  p.WaitWindow(''%s'',''%s'',%d,%d)',
                 [WndClass,WndCaption,WndIndex ,Diff]);
      2: Verb := Format('  %s.WaitWindowVisible(''%s'',''%s'',%d,%d)',
                [rsRecordDelay,WndClass,WndCaption,WndIndex ,Diff]);
    end;    // case
    if FScriptLang = DelphiScript then
        Verb := Verb + ';';
    Result := Verb;
//    PIManager.Recorder.AddString(Verb);
  end;
  FDelayStart := Now;
end;

var
  FixOpt: IPTAvailableOptions;
  FixEng: IPTEngines;

function AQtestPlugInInit(PlugInManager: IPIBaseManager): WordBool;
begin
  Result := True;
  try
    PIManager := PlugInManager as IPIManager;
    AQRecordDelayPlugIn := TAQRecordDelay.Create;
    AQRecordDelayPlugIn._AddRef;
    FixEng := PIManager.Engines;
    FixEng.AddEngine(AQRecordDelayPlugIn);

    FAQDelay :=  TAQRecordDelayObj.Create;



    PIManager.AddName(rsRecordDelay,False,FAQDelay);

    FixOpt := PIManager.AOptions;

    FixOpt.AddOption(AQRecordDelayPlugIn,'Enabled',AQRecordDelayPlugIn.FSettingsHolder.FEnabled);
    FixOpt.AddOption(AQRecordDelayPlugIn,'Delay Type',AQRecordDelayPlugIn.FSettingsHolder.FDelayType);
    PIManager.AddNotifier(IID_IPTHighRecorderNotifier,AQRecordDelayPlugIn);
    PIManager.AddNotifier(IID_IPTEngineNotifier,AQRecordDelayPlugIn);

    AQRecordDelayPlugIn.FHandle := FindWindow('TFormTopWindow',nil);

    if AQRecordDelayPlugIn.FHandle <> 0 then
      OldWndProc := Pointer(SetWindowLong(AQRecordDelayPlugIn.FHandle,GWL_WNDPROC,longint(@SubclassedWndProc)));



  except
    Result := False;
  end;
end;

procedure AQtestPlugInFinalize;
begin
  SetWindowLong(AQRecordDelayPlugIn.FHandle,GWL_WNDPROC,longint(OldWndProc));


  PIManager.RemoveName(rsRecordDelay);
  FixOpt.RemoveOptions(AQRecordDelayPlugIn);


  PIManager.RemoveNotifier(IID_IPTHighRecorderNotifier,AQRecordDelayPlugIn);
  PIManager.RemoveNotifier(IID_IPTEngineNotifier,AQRecordDelayPlugIn);
  FixEng.RemoveEngine(AQRecordDelayPlugIn);

  FixOpt := nil;
  AQRecordDelayPlugIn := nil;
end;

function AQtestPlugInDescription: WideString;
begin
  Result := 'Record Delay Support'
end;



function TAQRecordDelay.Get_Category: WideString;
begin
  Result := '';
end;

function TAQRecordDelay.Get_Icon: SYSUINT;
begin
  Result := FIcon;
end;

function TAQRecordDelay.Get_Name: WideString;
begin
  Result := 'AQRecordDelayPlugIn';
end;

function TAQRecordDelay.Get_Settings: IPTSettings;
begin
  Result := FPTSettings;
end;

procedure TAQRecordDelay.OnExecutePause;
begin

end;

procedure TAQRecordDelay.OnExecuteResume;
begin

end;


{procedure TAQRecordDelay.OnKeyDown(Scan, VK: Integer);
begin

end;

procedure TAQRecordDelay.OnKeyUp(Scan, VK: Integer);
begin
  if not FKey then
    AddDelay;
  FKey := True;
end;

procedure TAQRecordDelay.OnMouseDown(VK, X, Y: Integer);
begin
  AddDelay;
  FKey := False;
end;

procedure TAQRecordDelay.OnMouseMove(X, Y: Integer);
begin
  FKey := False;
end;

procedure TAQRecordDelay.OnMouseUp(VK, X, Y: Integer);
begin
  FKey := False;
end;

procedure TAQRecordDelay.OnMouseWheel(zDelta: Integer);
begin
  FKey := False;
end;

}
procedure TAQRecordDelay.OnCancel;
begin
  //
end;




function SubclassedWndProc(Hwnd:HWND; Msg:UINT; wParam:WPARAM; lParam:lParam):LResult; stdcall;
begin
  Result := CallWindowProc(OldWndProc,AQRecordDelayPlugIn.FHandle,MSG, WPARAM, LPARAM);
  if ((Msg = WM_NCLBUTTONDBLCLK) and (wParam = HTCAPTION)) then
  begin
    AQRecordDelayPlugIn.FEnabled := not AQRecordDelayPlugIn.FEnabled;
    AQRecordDelayPlugIn.UpdateCaption;
    Result := 0;
  end;

end;


procedure TAQRecordDelay.UpdateCaption;
begin
  if Enabled then
    SetWindowText(FHandle,'Recording with Delay')
  else
    SetWindowText(FHandle,'Recording');
end;


procedure TAQRecordDelay.OnClick(const AQtestObject: IAQtestObjectControl;
  X, Y: Integer; out Verb: WideString);
begin

end;

procedure TAQRecordDelay.OnClickM(const AQtestObject: IAQtestObjectControl;
  X, Y: Integer; out Verb: WideString);
begin

end;

procedure TAQRecordDelay.OnClickR(const AQtestObject: IAQtestObjectControl;
  X, Y: Integer; out Verb: WideString);
begin

end;

procedure TAQRecordDelay.OnClickX1(
  const AQtestObject: IAQtestObjectControl; X, Y: Integer;
  out Verb: WideString);
begin

end;

procedure TAQRecordDelay.OnClickX2(
  const AQtestObject: IAQtestObjectControl; X, Y: Integer;
  out Verb: WideString);
begin

end;

procedure TAQRecordDelay.OnDblClick(
  const AQtestObject: IAQtestObjectControl; X, Y: Integer;
  out Verb: WideString);
begin

end;

procedure TAQRecordDelay.OnDblClickM(
  const AQtestObject: IAQtestObjectControl; X, Y: Integer;
  out Verb: WideString);
begin

end;

procedure TAQRecordDelay.OnDblClickR(
  const AQtestObject: IAQtestObjectControl; X, Y: Integer;
  out Verb: WideString);
begin

end;

procedure TAQRecordDelay.OnDblClickX1(
  const AQtestObject: IAQtestObjectControl; X, Y: Integer;
  out Verb: WideString);
begin

end;

procedure TAQRecordDelay.OnDblClickX2(
  const AQtestObject: IAQtestObjectControl; X, Y: Integer;
  out Verb: WideString);
begin

end;

procedure TAQRecordDelay.OnDrag(const AQtestObject: IAQtestObjectControl;
  X, Y, toX, toY: Integer; out Verb: WideString);
begin

end;

procedure TAQRecordDelay.OnDragM(const AQtestObject: IAQtestObjectControl;
  X, Y, toX, toY: Integer; out Verb: WideString);
begin

end;

procedure TAQRecordDelay.OnDragR(const AQtestObject: IAQtestObjectControl;
  X, Y, toX, toY: Integer; out Verb: WideString);
begin

end;

procedure TAQRecordDelay.OnDragX1(const AQtestObject: IAQtestObjectControl;
  X, Y, toX, toY: Integer; out Verb: WideString);
begin

end;

procedure TAQRecordDelay.OnDragX2(const AQtestObject: IAQtestObjectControl;
  X, Y, toX, toY: Integer; out Verb: WideString);
begin

end;

procedure TAQRecordDelay.OnKeyPress(
  const AQtestObject: IAQtestObjectControl; Scan, VK: Integer;
  out Verb: WideString);
begin

end;

procedure TAQRecordDelay.OnNewContextProcess(
  const AQtestProcess: IAQtestObjectProcess; out Verb: WideString);
begin

end;

procedure TAQRecordDelay.OnNewContextWindow(
  const AQtestObject: IAQtestObjectWindow; out Verb: WideString);
begin

end;

function TAQRecordDelay.OnWillProcessEvent(
  const AQtestObject: IAQtestObject; HighEvent: THighEvents;
  out Verb: WideString): WordBool;
var
  temp:IAQtestObjectWindow;
begin
  Result := False;
  if Enabled and (FDelayStart <> 0) and (HighEvent <> heStopRecord) then
  begin
//    if (heNewContextProcess = HighEvent) then
//    begin
//
//      Verb := Format('  p := Sys.WaitProcess(''%s'',%d)',[(AQtestObject as IAQtestObjectProcess).ProcessName,GetDelayTime]);
//      if FScriptLang = DelphiScript then
//        Verb := Verb + ';';
//      Result := True;
//    end
//    else
//    if (heNewContextWindow = HighEvent) then
//    begin
//      temp := AQtestObject as IAQtestObjectWindow;
//      with temp do
//      begin
//        Verb := Format('  w := %s.WaitWindowVisible(''%s'',''%s'',%d,%d)',
//           [rsRecordDelay,WndClass,WndCaption,WndIndex ,GetDelayTime])
//
//      end;    // with
//      if FScriptLang = DelphiScript then
//        Verb := Verb + ';';
//    end
//    else
      Verb := AddDelay;
  end
  else
    GetDelayTime;
end;

function TAQRecordDelay.GetDelayTime: Integer;
begin
  Result := Round((Now - FDelayStart) * msecFactor);
  FDelayStart := Now;
end;

procedure TAQRecordDelay.SetLineType(LineStr: String);
begin
  if LineStr = 'Sys.Delay' then
    FLineType := 0
  else
    if LineStr = 'WaitWindow' then
      FLineType := 1
    else
      FLineType := 2;

    
end;

{ TAQRecordDelaySettings }

procedure TAQRecordDelaySettings.AddCancelNotifier(
  const Notifier: IPTSettingsCancelNotifier);
begin
end;

procedure TAQRecordDelaySettings.AddNotifier(
  const PTSettingsNotifier: IPTSettingsNotifier);
begin
end;

procedure TAQRecordDelaySettings.CancelSettings;
begin
end;

constructor TAQRecordDelaySettings.Create;
begin
  inherited Create(GetAQTestTypeLib,IPTSettings);
  FEnabled := TAQRecordDelaySetting.Create;
  FEnabled.FName := 'Enabled';
  FEnabled.FDataType := dtBoolean;
  FDelayType := TAQRecordDelaySetting.Create;
  FDelayType.FDataType := dtString;
  FDelayType.Kind := skPickList;
  FDelayType.FName := 'Delay Type';
end;

function TAQRecordDelaySettings.CreateSetting(
  const SettingName: WideString): IPTSetting;
begin
  if SettingName = 'Enabled' then
    Result := FEnabled
  else
    Result := FDelayType;
end;

destructor TAQRecordDelaySettings.Destroy;
begin
  FDelayType.Free;
  FEnabled.Free;
  inherited;
end;

procedure TAQRecordDelaySettings.ExecuteForm(HelpContextID: Integer);
begin
end;

function TAQRecordDelaySettings.Get_Count: Integer;
begin
  Result := 2;
end;

function TAQRecordDelaySettings.Get_FocusedIndex: Integer;
begin
 Result := FIndex;
end;

function TAQRecordDelaySettings.Get_HelpContext: Integer;
begin
end;

function TAQRecordDelaySettings.Get_HelpFileName: WideString;
begin
end;

function TAQRecordDelaySettings.Get_Name: WideString;
begin
  Result := 'Record Delay';
end;

function TAQRecordDelaySettings.Get_SettingByName(
  const Name: WideString): IPTSetting;
begin
  if Name = 'Enabled' then
    Result := FEnabled
  else
    Result := FDelayType;
end;

function TAQRecordDelaySettings.Get_Settings(Index: Integer): IPTSetting;
begin
  if Index = 0 then
    Result := FEnabled
  else
    Result := FDelayType;
end;

procedure TAQRecordDelaySettings.ReadSettings(const Options: IPTOptions);
var
  MyOptions: IPTOptions;
begin
  MyOptions := Options.GetSubSection('Recorder Delay');
  FEnabled.FValue := WordBool(MyOptions.GetOption('Enabled',False));
  FDelayType.FValue2 := MyOptions.GetOption('Delay Type','Sys.Delay');
  UpdateSettings;
end;

procedure TAQRecordDelaySettings.RemoveCancelNotifier(
  const Notifier: IPTSettingsCancelNotifier);
begin
end;

procedure TAQRecordDelaySettings.RemoveNotifier(
  const PTSettingsNotifier: IPTSettingsNotifier);
begin
end;

procedure TAQRecordDelaySettings.SaveSettings(const Options: IPTOptions);
var
  MyOptions: IPTOptions;
begin
  MyOptions := Options.GetSubSection('Recorder Delay');
  MyOptions.SetOption('Enabled',FEnabled.Value);
  MyOptions.SetOption('Delay Type',FDelayType.FValue2);
end;

procedure TAQRecordDelaySettings.Set_FocusedIndex(RetVal: Integer);
begin
  FIndex := RetVal;
end;

procedure TAQRecordDelaySettings.Set_HelpContext(RetVal: Integer);
begin
end;

procedure TAQRecordDelaySettings.Set_HelpFileName(
  const RetVal: WideString);
begin
end;

procedure TAQRecordDelaySettings.UpdateSettings;
begin
  AQRecordDelayPlugIn.FEngineEnabled := FEnabled.FValue;
  AQRecordDelayPlugIn.SetLineType(FDelayType.FValue2);
end;

{ TAQRecordDelaySetting }

procedure TAQRecordDelaySetting.AddCheckItem(const Name: WideString;
  Checked: WordBool);
begin
end;

function TAQRecordDelaySetting.CheckItemsCount: Integer;
begin
end;

constructor TAQRecordDelaySetting.Create;
begin
  inherited Create(GetAQTestTypeLib,IPTSetting);
  FString := TStringList.Create;
  FString.Add('Sys.Delay');
  FString.Add('WaitWindow');
  FString.Add('WaitWindowVisible');
end;

destructor TAQRecordDelaySetting.Destroy;
begin
  FString.Free;
  inherited;

end;

function TAQRecordDelaySetting.Get_ButtonClickNotifier: IPTSettingsButtonClickNotifier;
begin
end;

function TAQRecordDelaySetting.Get_Category: WideString;
begin
  Result := '';
end;

function TAQRecordDelaySetting.Get_CheckItemChecked(
  Index: Integer): WordBool;
begin
end;

function TAQRecordDelaySetting.Get_CheckItemName(
  Index: Integer): WideString;
begin
end;

function TAQRecordDelaySetting.Get_DataType: TDataType;
begin
  Result := FDataType;
end;

function TAQRecordDelaySetting.Get_Description: WideString;
begin
  Result := 'Enable Entry of Sys.Delay on user actions';
end;

function TAQRecordDelaySetting.Get_Kind: TSettingKind;
begin
//  Result := skNone;
  inherited;
end;

function TAQRecordDelaySetting.Get_MaxValue: OleVariant;
begin
end;

function TAQRecordDelaySetting.Get_MinValue: OleVariant;
begin
end;

function TAQRecordDelaySetting.Get_Name: WideString;
begin
  Result := FName;
end;

function TAQRecordDelaySetting.Get_ReadOnlyCheckList: WordBool;
begin
end;

function TAQRecordDelaySetting.Get_Strings: WideString;
begin
  Result := FString.Text;
end;

function TAQRecordDelaySetting.Get_Value: OleVariant;
begin
  if FName = 'Enabled' then
    Result := WordBool(FValue)
  else
    Result := FValue2;
end;

function TAQRecordDelaySetting.Get_Visible: WordBool;
begin
  Result := True;
end;

procedure TAQRecordDelaySetting.RemoveCheckItem(Index: Integer);
begin
end;

procedure TAQRecordDelaySetting.Set_ButtonClickNotifier(
  const Notifier: IPTSettingsButtonClickNotifier);
begin
end;

procedure TAQRecordDelaySetting.Set_Category(const RetVal: WideString);
begin
end;

procedure TAQRecordDelaySetting.Set_CheckItemChecked(Index: Integer;
  Value: WordBool);
begin
end;

procedure TAQRecordDelaySetting.Set_CheckItemName(Index: Integer;
  const Value: WideString);
begin
end;

procedure TAQRecordDelaySetting.Set_DataType(RetVal: TDataType);
begin
end;

procedure TAQRecordDelaySetting.Set_Description(const RetVal: WideString);
begin
end;

procedure TAQRecordDelaySetting.Set_Kind(Value: TSettingKind);
begin
  inherited;
end;

procedure TAQRecordDelaySetting.Set_MaxValue(RetVal: OleVariant);
begin
end;

procedure TAQRecordDelaySetting.Set_MinValue(RetVal: OleVariant);
begin
end;

procedure TAQRecordDelaySetting.Set_ReadOnlyCheckList(Value: WordBool);
begin
end;

procedure TAQRecordDelaySetting.Set_Strings(const RetVal: WideString);
begin
  FString.Text := RetVal;
end;

procedure TAQRecordDelaySetting.Set_Value(RetVal: OleVariant);
begin
 if FName = 'Enabled' then
   FValue := RetVal
 else
   FValue2 := RetVal;
end;

procedure TAQRecordDelaySetting.Set_Visible(Value: WordBool);
begin
end;

{ TASRecordDelayObj }

constructor TAQRecordDelayObj.Create;
begin
  inherited Create(GetModuleTypeLib,IAQRecordDelay);
end;

function TAQRecordDelayObj.WaitWindowVisible(const WndClass, WndCaption:
    WideString; WndIndex, WaitTime: Integer): IDispatch;
var
  DispatchHolder:OLEVariant;
  EndTime:Int64;
  CTime:Int64;
begin
  EndTime := GetTickCount + WaitTime;
  DispatchHolder := PIManager.Sys.ActiveWindow.ParentObject.WaitWindow(WndClass,WndCaption,WndIndex,WaitTime);
  if DispatchHolder.Exists then
  begin
    CTime := GetTickCount;
    while (not DispatchHolder.Visible) and (CTime <= EndTime) do
    begin
      Sleep(100);
      CTime := GetTickCount;
    end;    // while
  end;
  Result := DispatchHolder;
end;

end.
